package com.jpattern.orm.test.session;

import com.jpattern.orm.BaseTest;
import com.jpattern.orm.NullOrmClassToolMap;
import com.jpattern.orm.session.ISession;
import com.jpattern.orm.session.ISessionProvider;
import com.jpattern.orm.session.Session;
import com.jpattern.orm.transaction.ITransaction;

/**
 * 
 * @author Francesco Cina
 *
 * 05/giu/2011
 */
public class DataSourceConnectionTest extends BaseTest {

	protected void setUp() throws Exception {
		super.setUp();
	}

	protected void tearDown() throws Exception {
		super.tearDown();
	}
	
	public void testConnections() throws Exception {
		ISessionProvider provider = getSessionProvider();
		loopTransaction( provider );
		loopConnection( provider );
	}
	
	public void loopTransaction(ISessionProvider dsProvider) throws Exception {
		ISession conn = new Session(new NullOrmClassToolMap(), dsProvider.getSessionStrategy());

		int howMany = 1000;
		
		for (int i=0; i<howMany; i++) {
			ITransaction tx = conn.getTransaction();
			tx.commit();
			System.out.println("commit: " + i);
		}
		
		for (int i=0; i<howMany; i++) {
			ITransaction tx = conn.getTransaction();
			tx.rollback();
			System.out.println("rollback: " + i);
		}
	}
	
	public void loopConnection(ISessionProvider dsProvider) throws Exception {

		int howMany = 100;
		
		for (int i=0; i<howMany; i++) {
			ISession conn = new Session(new NullOrmClassToolMap(), dsProvider.getSessionStrategy());
			ITransaction tx = conn.getTransaction();
			tx.commit();
			System.out.println("commit: " + i);
		}
		
		for (int i=0; i<howMany; i++) {
			ISession conn = new Session(new NullOrmClassToolMap(), dsProvider.getSessionStrategy());
			ITransaction tx = conn.getTransaction();
			tx.rollback();
			System.out.println("rollback: " + i);
		}
	}
}
